<?php
/* E-Mail encryptor 
* obfuscates simple e-mail addresses
* obfuscates mailto: links trough javascript
* leaves e-mail addresses untouched inside form tags
* copyright  2010-2014 by manu @ www.pixolution.ch
* This plugin is free software and is subject 
*  to the same licence conditions as CMSimple is.
* see readme.1st   
*/

/*
 * Prevent direct access and usage from unsupported CMSimple_XH versions.
 */
if ( CMSIMPLE_XH_VERSION !== '@CMSIMPLE_XH_VERSION@' ) {
    if (!defined('CMSIMPLE_XH_VERSION')
        || strpos(CMSIMPLE_XH_VERSION, 'CMSimple_XH') !== 0
        || version_compare(CMSIMPLE_XH_VERSION, 'CMSimple_XH 1.5.4', 'lt')
    ) {
        header('HTTP/1.1 403 Forbidden');
        header('Content-Type: text/plain; charset=UTF-8');
        die(<<<EOT
encmail_XH detected an unsupported CMSimple_XH version.
Uninstall encmail_XH or upgrade to a supported CMSimple_XH version!
EOT
        );
    }
    
}

$encmail_obfuscate = isset($plugin_cf['encmail']['obfuscate'])? $plugin_cf['encmail']['obfuscate'] : 'none';

//pagewise obfuscation set by pagedata field
if ($encmail_obfuscate == 'page') {

    // just in case the pagedata field is not initiated
    $pd_router -> add_interest('encmail_obfuscate'); 
    
    if ($pd_current['encmail_obfuscate'] != 'true') $encmail_obfuscate ='none';
}

//obfuscate only in view mode
if (!XH_ADM || !$edit) {
    if ($encmail_obfuscate != 'none') define('ENCMAIL_SET',true);
} 
unset($encmail_obfuscate);

if (defined('ENCMAIL_SET')) $hjs.='<script type="text/javascript" src="'.$pth['folder']['plugin'].'encmail.js"></script>
';

/**
 * Obfuscates e-mail addresses and their links.
 *
 * @param string $content selected
 *
 * @return void
 *
 * @global array The configuration of the plugin.
 */

function encMail(&$c){
    global $plugin_cf;
    if (!defined ('ENCMAIL_SET')) return;
    $visible_at = str_replace('@','&#64;',$plugin_cf['encmail']['visible-at_as']);
    $rMail = '(?P<name>[_a-z0-9-]+(\.[_a-z0-9-]+)*)@(?P<host>[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4}))';
    $rLinkMail = '(?P<lname>[_a-z0-9-]+(\.[_a-z0-9-]+)*)@(?P<lhost>[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4}))';
      $regi = '/((?U)<form.*>.*<\/form>)|(?P<plainMail>' . $rMail . ')|(?P<linkMail>mailto:' . $rLinkMail . '(?P<query>\?[^"]+)?)/is';
    $c = preg_replace_callback($regi,
        function($matches) use ($visible_at){
            if ( !empty($matches['plainMail']))	// straight mail address
                return "<span style=\"display: none;\">".rand(5000, 50000)."</span>$matches[3]<span style=\"display: none;\">".rand(5000, 50000)."</span><span style=\"display: none;\">".rand(5000, 50000)."</span>$visible_at<span style=\"display: none;\">".rand(5000, 50000)."</span><span style=\"display: none;\">".rand(5000, 50000)."</span>$matches[5]<span style=\"display: none;\">".rand(5000, 50000)."</span>";
                
            if ( !empty($matches['linkMail'])) {	// mailto:
                $matches['query'] = !empty($matches['query'])?$matches['query']:'';
                return "javascript:void(0);\" onfocus=\"bingo(this,'{$matches['lname']}','{$matches['lhost']}{$matches['query']}');\" onblur=\"bingo(this);";
                
            }
            return $matches[1];	//mail address inside form tags: return untouched
        }
    ,$c);
}

/**
 * Obfuscates single e-mail address and eventually its link - template function.
 *
 * @param string e-mail address
 *
 * @param bool addLink?
 *
 * @return string generated html
 *
 * @global array The configuration of the plugin.
 */

function encMail_obfuscateSingleAddress($email,$addLink=false) {
    global $plugin_cf;
    $encMailVar=is_bool($addLink)? "mailto:{$email}" : $addLink;
    if ($addLink && $plugin_cf['encmail']['obfuscate'] !='none') encMail($encMailVar);
    $encMailVar2=$email;
    if ($plugin_cf['encmail']['obfuscate'] !='none') encMail($encMailVar2);
    if ($addLink)
        return <<<EOS
<a href="$encMailVar">$encMailVar2</a>
EOS;
    else
        return <<<EOS
$encMailVar2
EOS;
}

/**
 * Obfuscates single e-mail addresses in output buffer - template function.
 *
 * @return void
 */

function encMailTplBottom(){
    $html = ob_get_contents();
    ob_clean();
    encMail($html);
    echo $html;
}
?>